//******************************************************************
//      MSTEP2 test program
//                                              Chi-Mou Chao 3/15/98
//******************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <math.h>
#include <string.h>
#include <bios.h>

#include "mstep2.h"
#define  CARD1    0
//-------------define display color for color

#define COM_BACK          BLUE
#define COM_TEXT          WHITE
#define COM_UP_BACK       WHITE
#define COM_UP_TEXT       BLACK+BLINK
#define COM_ON_BACK       RED
#define COM_ON_TEXT       WHITE

#define SYS_ON_BACK       MAGENTA
#define SYS_ON_TEXT       WHITE
#define SYS_OFF_BACK      CYAN
#define SYS_OFF_TEXT      WHITE

#define SCREEN       WHITE
#define SCREEN_BACK  BLUE

//-----type definition --------------------------
typedef char string30[30];
typedef struct {
                 int       max;
                 string30  name[30];
                 int       x[30],y[30];
               } menutype;
//-----variable definition-----------------------
menutype      menu;

char          screen_buffer[4096];
unsigned char DDA,AD;
unsigned int  LSP,HSP;
unsigned char xmode,ymode;
unsigned char xdir,ydir;
unsigned char xson,yson;

int    i,j;
//####################################################################
//####################################################################
void unpressed_text(unsigned char x, unsigned char y,
                    string30 show_text)
{
  textbackground(COM_BACK);
  textcolor(COM_TEXT);
  gotoxy(x,y);
  cprintf(show_text);
  gotoxy(x,y);
}
//----------------------------------------------------------
void pressed_text(unsigned char x, unsigned char y,
                    string30 show_text)
{
  textbackground(COM_UP_BACK);
  textcolor(COM_UP_TEXT);
  gotoxy(x,y);
  cprintf(show_text);
  gotoxy(x,y);
}
//----------------------------------------------------------
void work_text(unsigned char x, unsigned char y,
                    string30 show_text)
{
  textbackground(COM_ON_BACK);
  textcolor(COM_ON_TEXT);
  gotoxy(x,y);
  cprintf(show_text);
  gotoxy(x,y);
}
//---------------------------------------------------------
void init_system_display()
{
   //---- print title ------
   textbackground(SYS_ON_BACK);
   textcolor(SYS_ON_TEXT);
   gotoxy(1,1);
   cprintf(
"              2 Axes Stepping Motor Control Card     version 0.9   C.C.M.3/15/98");

   window(1,2,27,25);
   textbackground(SYS_OFF_BACK);
   textcolor(SYS_OFF_TEXT);
   clrscr();
   //-------- show pannel
   window(1,1,80,25);
   textbackground(SYS_ON_BACK);
   textcolor(SYS_ON_TEXT);
   gotoxy(1,2);   cprintf("       Limit Switch        ");
   gotoxy(1,11);   cprintf("      Motion Parameter     ");

   menu.max=23;
   for (i=0; i<12; i++)
   {
      menu.x[i]=30;
      menu.y[i]=2+i*2;
   }
   for (i=12; i<24; i++)
   {
      menu.x[i]=55;
      menu.y[i]=2+(i-12)*2;
   }

   strcpy(menu.name[0], " MSTEP2_SET_VAR        ");
   strcpy(menu.name[1], " MSTEP2_SET_MODE       ");
   strcpy(menu.name[2], " MSTEP2_SET_DIRDEF     ");
   strcpy(menu.name[3], " MSTEP2_SET_SERVO_ON   ");
   strcpy(menu.name[4], " MSTEP2_STOP_ALL       ");
   strcpy(menu.name[5], " MSTEP2_RESET_SYSTEM   ");
   strcpy(menu.name[6], " MSTEP2_LSP_ORG        ");
   strcpy(menu.name[7], " MSTEP2_HSP_ORG        ");
   strcpy(menu.name[8], " MSTEP2_HSD_ORG        ");
   strcpy(menu.name[9], " MSTEP2_CSP_MOVE       ");
   strcpy(menu.name[10]," MSTEP2_SLOW_DOWN      ");
   strcpy(menu.name[11]," MSTEP2_SLOW_STOP      ");
   strcpy(menu.name[12]," MSTEP2_LSP_PULSE_MOVE ");
   strcpy(menu.name[13]," MSTEP2_HSP_PULSE_MOVE ");
   strcpy(menu.name[14]," MSTEP2_INTP_PULSE     ");
   strcpy(menu.name[15]," MSTEP2_INTP_LINE      ");
   strcpy(menu.name[16]," MSTEP2_INTP_LONG_LINE ");
   strcpy(menu.name[17]," MSTEP2_INTP_CIRCLE    ");
   strcpy(menu.name[18]," MSTEP2_INTP_ARC       ");
   strcpy(menu.name[19]," MSTEP2_INTP_LINE02    ");
   strcpy(menu.name[20]," MSTEP2_INTP_CIRCLE02  ");
   strcpy(menu.name[21]," MSTEP2_INTP_ARC02     ");
   strcpy(menu.name[22],"  User Define Testing  ");

   for (i=0; i<menu.max; i++)
     unpressed_text (menu.x[i], menu.y[i], menu.name[i]);
}
//#############################################################
//#############################################################
void turn_lamp(unsigned char lswitch,
               unsigned char x,
               unsigned char y,
               string30      show_text)
{
  if (lswitch!=0)
      {
        textbackground(SYS_OFF_BACK);
        textcolor(SYS_OFF_TEXT);
      }
  else
      {
        textbackground(SYS_ON_BACK);
        textcolor(SYS_ON_TEXT);
      }
  gotoxy(x,y);
  cprintf(show_text);
}
//-------------------------------------------------------------
void display_switch(void)
{
unsigned char x_limit, y_limit;

  x_limit = MSTEP2_LIMIT_X(CARD1);
  y_limit = MSTEP2_LIMIT_Y(CARD1);

  turn_lamp(x_limit & 0x01,2,3, "ORG1");
  turn_lamp(x_limit & 0x02,2,4, "LS11");
  turn_lamp(x_limit & 0x04,2,5, "LS12");
  turn_lamp(x_limit & 0x08,2,6, "LS13");
  turn_lamp(x_limit & 0x10,2,7, "LS14");
  turn_lamp(x_limit & 0x20,2,8, "FFEF");
  turn_lamp(x_limit & 0x40,2,9, "FFFF");
  turn_lamp(x_limit & 0x80,2,10,"/EMG");

  turn_lamp(y_limit & 0x01,8,3, "ORG2");
  turn_lamp(y_limit & 0x02,8,4, "LS21");
  turn_lamp(y_limit & 0x04,8,5, "LS22");
  turn_lamp(y_limit & 0x08,8,6, "LS23");
  turn_lamp(y_limit & 0x10,8,7, "LS24");
  turn_lamp(y_limit & 0x20,8,8, "CPUS");
  turn_lamp(y_limit & 0x40,8,9, "XSTP");
  turn_lamp(y_limit & 0x80,8,10,"YSTP");
}

//--------------------------------------------------
void show_sts(void)
{
unsigned char cpu_ls, msc;

  turn_lamp(cpu_ls & 0x01,14,3, "TP11");
  turn_lamp(cpu_ls & 0x02,14,4, "TP12");
  turn_lamp(cpu_ls & 0x04,14,5, "TP13");
  turn_lamp(cpu_ls & 0x08,14,6, "TP14");
  turn_lamp(cpu_ls & 0x10,14,7, "TP21");
  turn_lamp(cpu_ls & 0x20,14,8, "TP22");
  turn_lamp(cpu_ls & 0x40,14,9, "TP23");
  turn_lamp(cpu_ls & 0x80,14,10,"TP24");

  turn_lamp(msc & 0x01,20,3, "TPEF");
  turn_lamp(msc & 0x02,20,4, "    ");
  turn_lamp(msc & 0x04,20,5, "    ");
  turn_lamp(msc & 0x08,20,6, "/TPG");
  turn_lamp(msc & 0x10,20,7, "TPG1");
  turn_lamp(msc & 0x20,20,8, "TPG2");
  turn_lamp(msc & 0x40,20,9, "    ");
  turn_lamp(msc & 0x80,20,10,"    ");
}
//------------------------------------------------------------
void show_var()
{
  window(1,1,80,25);
  textbackground(SYS_OFF_BACK);
  textcolor(SYS_OFF_TEXT);
  gotoxy(2,12); cprintf("DDA cycle    = %d      ",DDA);
  gotoxy(2,13); cprintf("ACC/DEC      = %d      ",AD);
  gotoxy(2,14); cprintf("Low Speed    = %d      ",LSP);
  gotoxy(2,15); cprintf("High Speed   = %d      ",HSP);
  gotoxy(2,16); cprintf("X output mode=            ");
  if (xmode==CW_CCW)
   {
     gotoxy(17,16);  cprintf("CW/CCW");
   }
  else
   {
     gotoxy(17,16);  cprintf("PULSE/DIR");
   };

  gotoxy(2,17); cprintf("Y output mode=            ");
  if (ymode==CW_CCW)
   {
     gotoxy(17,17);  cprintf("CW/CCW");
   }
  else
   {
     gotoxy(17,17);  cprintf("PULSE/DIR");
   };

  gotoxy(2,18); cprintf("X direction  =           ");
  if (xdir==NORMAL_DIR)
   {
     gotoxy(17,18);  cprintf("NORMAL");
   }
  else
   {
     gotoxy(17,18);  cprintf("REVERSE");
   };
  gotoxy(2,19); cprintf("Y direction  =           ");
  if (ydir==NORMAL_DIR)
   {
     gotoxy(17,19);  cprintf("NORMAL");
   }
  else
   {
     gotoxy(17,19);  cprintf("REVERSE");
   };

  gotoxy(2,20); cprintf("X servo on   =         ");
  if (xson==ON)
   {
     gotoxy(17,20);  cprintf("ON");
   }
  else
   {
     gotoxy(17,20);  cprintf("OFF");
   };

  gotoxy(2,21); cprintf("Y servo on   =         ");
  if (yson==ON)
   {
     gotoxy(17,21);  cprintf("ON");
   }
  else
   {
     gotoxy(17,21);  cprintf("OFF");
   };
}
//#############################################################
char *input_string(int x, int y, int max, char istr[30], int fch)
{
   int   l,c,j;
   int  ch,ch1;

   l=strlen(istr);
   c=l;
   if (c>=max) c=max-1;
   ch=fch;
   textbackground(WHITE); textcolor(BLACK);
   gotoxy(x,y); for (j=0; j<max; j++) cprintf(" ");
   gotoxy(x,y); cprintf(istr);
   gotoxy(x+c,y);
  do {
    switch (ch) {
    case 0x4b00: c--; if (c<0) c=0;         /* left */
                 break;
    case 0x4d00: c++; if (c>l) c=l;   /* right */
                      if (c>max-1) c=max-1;
                 break;
    case 0x5300: if (l>0)                   /* del */
                   {
                     for (j=c; j<l; j++) istr[j]=istr[j+1];
                     istr[j]='\0'; l=strlen(istr);
                   }
                 break;
    case 0x0e08: c--;                       /* backspace */
                 if (c<0) c=0;
                 else
                   {
                     for (j=c; j<l; j++) istr[j]=istr[j+1];
                     istr[j]='\0'; l=strlen(istr);
                   }
                 break;

    default: ch1=ch&0x00ff;
             if ((ch1>12)&(ch1<122))
             {
               if ( c>=strlen(istr))
                  {
                  istr[c]=ch1; istr[c+1]='\0'; c++;
                  }
               else { istr[c]=ch1; c++;};

               if (c>max-1) c=max-1;
             }

             break;
                 }
     l=strlen(istr);
     textbackground(7); textcolor(0);
     gotoxy(x,y); for (j=0; j<max; j++) cprintf(" ");
     textbackground(7); textcolor(0);
     gotoxy(x,y); cprintf(istr);
     gotoxy(x+c,y);

     do {
        } while (!bioskey(1));
        ch=bioskey(0);

    } while (ch!=0x1c0d);
    return (istr);
}
//----------------------------------------------------------------
long get_number(string30 show_text)
{
string30 tstr;
long temp;

  gettext(20,11,60,13,screen_buffer);
  textbackground(BLACK);
  textcolor(WHITE);
  window(20,11,60,13);
  clrscr();

  gotoxy(2,2);
  cprintf(show_text);
  strcpy(tstr,"");
  temp = atol(input_string(wherex(),wherey(),10,tstr,0) );

  window(1,1,80,25);
  puttext(20,11,60,13,screen_buffer);
  return temp;
}
//--------------------------------------------------------
void wait_key(string30 show_text)
{
  gettext(20,11,60,13,screen_buffer);
  textbackground(BLACK);
  textcolor(WHITE);
  window(20,11,60,13);
  clrscr();

  gotoxy(2,2);
  cprintf(show_text);
  do
   {}
  while (!kbhit());
  getch();
  window(1,1,80,25);
  puttext(20,11,60,13,screen_buffer);
}
//--------------------------------------------------------------------
void MessageBox(string30 show_text)
{
  disable();
  gettext(40,11,80,13,screen_buffer);
  textbackground(WHITE);
  textcolor(BLACK);
  window(40,11,80,13);
  clrscr();
  window(1,1,80,25);
  gotoxy(40,11); cprintf("ͻ");
  gotoxy(40,12); cprintf("                                       ");
  gotoxy(40,13); cprintf("ͼ");

  gotoxy(42,12);
  cprintf(show_text);
  enable();

  do { delay(10); } while (!kbhit());
  bioskey(0);
  window(1,1,80,25);
  puttext(40,11,80,13,screen_buffer);
}
//*********************************************************
void set_var()
{
  DDA = 3;
  AD  = 5;
  LSP = 10;
  HSP = 150;
  xmode = CW_CCW;
  ymode = CW_CCW;
  xdir = NORMAL_DIR;
  ydir = NORMAL_DIR;
  xson = ON;
  yson = ON;

  MSTEP2_REGISTRATION(CARD1, 0x300);
  MSTEP2_RESET_SYSTEM(CARD1);
  MSTEP2_SET_VAR(CARD1, DDA, AD, LSP, HSP);
  MSTEP2_SET_DEFDIR(CARD1, xdir, ydir);
  MSTEP2_SET_MODE(CARD1, xmode, ymode);
  MSTEP2_SET_SERVO_ON(CARD1, xson, yson);
  MSTEP2_SET_NC(CARD1, NO);
  show_var();
  show_sts();
}
//*********************************************************
void operate_MSTEP2(unsigned char command)
{
unsigned char axis,dir;
unsigned int  speed;
long          pulse;
int           pulsex,pulsey;
long          x,y,R;

 switch (command)
 {
  case 0 : //MSTEP2_SET_VAR
            DDA=(unsigned char) get_number("DDA cycle (1~254) = ");
            AD=(unsigned char) get_number("Acc/Dec (1~200) = ");
            LSP=(unsigned int) get_number("Low Speed (1~200) = ");
            HSP=(unsigned int) get_number("High Speed (1~2047) = ");
            if ((DDA==0) || (DDA>254)) break;
            if ((AD==0) || (AD>200)) break;
            if ((LSP==0) || (LSP>200)) break;
            if ((HSP<LSP) || (HSP>2047)) break;

            MSTEP2_SET_VAR(CARD1, DDA,AD,LSP,HSP);
            show_var();
            break;

  case 1 : //MSTEP2_SET_MODE
            xmode=(unsigned char) get_number("X mode 0:CW/CCW, 1:PULSE/DIR = ");
            ymode=(unsigned char) get_number("Y mode 0:CW/CCW, 1:PULSE/DIR = ");
            if ((xmode!=CW_CCW) && (xmode!=PULSE_DIR)) break;
            if ((ymode!=CW_CCW) && (ymode!=PULSE_DIR)) break;

            MSTEP2_SET_MODE(CARD1, xmode, ymode);
            show_var();
            break;

  case 2 : //MSTEP2_SET_DIRDEF
            xdir=(unsigned char) get_number("X dir 0:NORMAL, 1:REVERSE = ");
            ydir=(unsigned char) get_number("Y dir 0:NORMAL, 1:REVERSE = ");
            if ((xdir!=NORMAL_DIR) && (xdir!=REVERSE_DIR)) break;
            if ((ydir!=NORMAL_DIR) && (ydir!=REVERSE_DIR)) break;

            MSTEP2_SET_DEFDIR(CARD1, xdir, ydir);
            show_var();
            break;

  case 3 : //MSTEP2_SET_SERVO_ON
            xson=(unsigned char) get_number("X servo on  0:OFF, 1:ON = ");
            yson=(unsigned char) get_number("Y servo on  0:OFF, 1:ON = ");
            if ((xson!=ON) && (xson!=OFF)) break;
            if ((yson!=ON) && (yson!=OFF)) break;

            MSTEP2_SET_SERVO_ON(CARD1, xson, yson);
            show_var();
            break;

  case 4 : //MSTEP2_STOP_ALL
            //MSTEP2_STOP_X(CARD1);
            //MSTEP2_STOP_Y(CARD1);
            MSTEP2_STOP_ALL(CARD1);
            break;

  case 5 : //MSTEP2_RESET_SYSTEM
            MSTEP2_RESET_SYSTEM(CARD1);
            set_var();
            break;

  case 6 : //MSTEP2_LSP_ORG
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            if ((axis!=1) && (axis!=2)) break;
            MSTEP2_LSP_ORG(CARD1,CCW,axis);
            break;

  case 7 : //MSTEP2_HSP_ORG
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            if ((axis!=1) && (axis!=2)) break;
            MSTEP2_HSP_ORG(CARD1,CCW,axis);
            break;

  case 8 : //MSTEP2_HSD_ORG
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            if ((axis!=1) && (axis!=2)) break;
            MSTEP2_HSD_ORG(CARD1,CCW,axis);
            break;

  case 9 : //MSTEP2_CSP_MOVE
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
            speed =(unsigned int) get_number("input speed (1~2047) = ");
            if ((axis!=1) && (axis!=2)) break;
            if ((dir!=CW) && (dir!=CCW)) break;
            if ((speed==0) || (speed>2047)) break;
            //MSTEP2_LSP_MOVE(CARD1,dir,axis);
            //MSTEP2_HSP_MOVE(CARD1,dir,axis);
            MSTEP2_CSP_MOVE(CARD1,dir,axis,speed);
            break;

  case 10 : //MSTEP2_SLOW_DOWN
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            if ((axis!=1) && (axis!=2)) break;
            MSTEP2_SLOW_DOWN(CARD1,axis);
            break;

  case 11 : //MSTEP2_SLOW_STOP
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            if ((axis!=1) && (axis!=2)) break;
            MSTEP2_SLOW_STOP(CARD1,axis);
            break;

  case 12 : //MSTEP2_LSP_PULSE_MOVE
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            pulse=(long) get_number("input pulse (+- 2^31 -1) = ");
            if ((axis!=1) && (axis!=2)) break;
            MSTEP2_LSP_PULSE_MOVE(CARD1,axis,pulse);
            break;

  case 13 : //MSTEP2_HSP_PULSE_MOVE
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            axis=(unsigned char) get_number("1: X axis,  2: Y axis = ");
            pulse=(long) get_number("input pulse (+- 2^31 -1) = ");
            if ((axis!=1) && (axis!=2)) break;
            MSTEP2_HSP_PULSE_MOVE(CARD1,axis,pulse);
            break;

  case 14 : //MSTEP2_INTP_PULSE
            pulsex=(int) get_number("X pulse number (-2047 ~ 2047) = ");
            pulsey=(int) get_number("Y pulse number (-2047 ~ 2047) = ");
            if (abs(pulsex) > 2047 ) break;
            if (abs(pulsey) > 2047 ) break;
            MSTEP2_INTP_PULSE(CARD1,pulsex,pulsey);
            MSTEP2_WAIT_X(CARD1);
            MSTEP2_WAIT_Y(CARD1);
            break;

  case 15 : //MSTEP2_INTP_LINE
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            x=(long) get_number("X pulse number (+- 524287) = ");
            y=(long) get_number("Y pulse number (+- 524287) = ");
            if (labs(x) > 524287) break;
            if (labs(y) > 524287) break;
            MSTEP2_INTP_LINE(CARD1,x,y);
            break;

  case 16 : //MSTEP2_INTP_LONG_LINE
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            x=(long) get_number("X pulse number (+- 2^31 -1) = ");
            y=(long) get_number("Y pulse number (+- 2^31 -1) = ");
            speed=(unsigned int) get_number("speed (<2040)= ");
            MSTEP2_INTP_LONG_LINE(CARD1,x,y,speed);
            break;

  case 17 : //MSTEP2_CIRCLE
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            x=(long) get_number("center point X = ");
            y=(long) get_number("center point Y = ");
            dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
            speed=(unsigned int) get_number("speed (<2040)= ");
            if ((dir!=CW) && (dir!=CCW)) break;
            MSTEP2_CIRCLE(CARD1,x,y,dir,speed);
            break;

  case 18 : //MSTEP2_ARC
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            x=(long) get_number("center point X = ");
            y=(long) get_number("center point Y = ");
            R=(long) get_number("Radius = ");
            dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
            speed=(unsigned int) get_number("speed (<2040)= ");
            if ((dir!=CW) && (dir!=CCW)) break;
            MSTEP2_ARC(CARD1,x,y,R,dir,speed);
            break;

  case 19 : //MSTEP2_INTP_LINE02
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            x=(long) get_number("X pulse number (+- 2^31 -1) = ");
            y=(long) get_number("Y pulse number (+- 2^31 -1) = ");
            speed=(unsigned int) get_number("speed (<2040)= ");
            MSTEP2_INTP_LINE02(CARD1,x,y,speed,0);
            do {} while (MSTEP2_INTP_STOP()!=READY);
            break;

  case 20 : //MSTEP2_CIRCLE02
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            x=(long) get_number("center point X = ");
            y=(long) get_number("center point Y = ");
            dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
            speed=(unsigned int) get_number("speed (<2040)= ");
            if ((dir!=CW) && (dir!=CCW)) break;
            MSTEP2_INTP_CIRCLE02(CARD1,x,y,dir,speed,0);
            do {} while (MSTEP2_INTP_STOP()!=READY);
            break;

  case 21 : //MSTEP2_ARC02
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };
            x=(long) get_number("center point X = ");
            y=(long) get_number("center point Y = ");
            R=(long) get_number("Radius = ");
            dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
            speed=(unsigned int) get_number("speed (<2040)= ");
            if ((dir!=CW) && (dir!=CCW)) break;
            MSTEP2_INTP_ARC02(CARD1,x,y,R,dir,speed,0);
            do {} while (MSTEP2_INTP_STOP()!=READY);
            break;

  case 22 : //User Define Testing
            if (    (MSTEP2_IS_X_STOP(CARD1)==NO)
                 || (MSTEP2_IS_Y_STOP(CARD1)==NO)
               )
            {
               MessageBox("Inhibit now!");
               break;
            };

            //wait for others interpolation completed
            do {} while (MSTEP2_INTP_STOP()!=READY);

            //test LINE02, no acceleration
            MSTEP2_INTP_LINE02(CARD1,1000,1000,20,1);
            do {} while (MSTEP2_INTP_STOP()!=READY);
            MSTEP2_INTP_LINE02(CARD1,2000,1000,22,1);
            do {} while (MSTEP2_INTP_STOP()!=READY);
            MSTEP2_INTP_LINE02(CARD1,2000,2000,24,1);
            do {} while (MSTEP2_INTP_STOP()!=READY);
            MSTEP2_INTP_LINE02(CARD1,1000,2000,26,1);
            do {} while (MSTEP2_INTP_STOP()!=READY);

            do {} while (MSTEP2_IS_X_STOP(CARD1)==NO);
            delay(2000);

            //test WAIT_X, WAIT_Y, WAIT_Z
            MSTEP2_INTP_LINE02(CARD1, 10000,-10000,150,0);
            do {} while (MSTEP2_INTP_STOP()!=READY);
            MSTEP2_INTP_LINE02(CARD1, -10000, 10000,150,0);
            do {} while (MSTEP2_INTP_STOP()!=READY);

            do {} while (MSTEP2_IS_X_STOP(CARD1)==NO);
            do {} while (MSTEP2_IS_Y_STOP(CARD1)==NO);
            MSTEP2_STOP_ALL(CARD1);
            delay(2000);

            MSTEP2_INTP_CIRCLE02(CARD1, 5000,-5000, CW, 150, 0);
            do {} while (MSTEP2_INTP_STOP()!=READY);

            do {} while (MSTEP2_IS_X_STOP(CARD1)==NO);
            do {} while (MSTEP2_IS_Y_STOP(CARD1)==NO);
            MSTEP2_STOP_ALL(CARD1);
            break;

  default: break;
 }
}
//#############################################################
//*************************************************************
void main()
{
  int  c,oldc,chkey;

  textbackground(SCREEN_BACK);
  clrscr();
  //initial system value
  set_var();

  init_system_display();
  show_var();
  show_sts();

// operation -----------------------------------------------------------------
  textbackground(COM_UP_BACK);
  textcolor(COM_UP_TEXT);
  gotoxy(28,25);
  cprintf(" ESC:EXIT F7:STOP  Up,Down:move  Enter:select  ");
  c=0; oldc=0;

  pressed_text(menu.x[c], menu.y[c], menu.name[c]);
  do
  {
     do
      {
        delay(50);
        display_switch();
      } while (!kbhit());
    chkey=bioskey(0);
    switch (chkey)
      {
      case 0x4d00 : c +=12;
                    if (c>=menu.max) c -=12;   // right
                    break;
      case 0x4b00 : c -=12;
                    if (c<0)  c +=12;          // left
                    break;
      case 0x5000 : c++;
                    if ( c>=menu.max ) c=0;    // down
                    break;
      case 0x4800 : c--;
                    if ( c<0 ) c=menu.max-1;   // up
                    break;

      case 0x1c0d : work_text(menu.x[c], menu.y[c], menu.name[c]);
                    operate_MSTEP2(c);          // enter
                    pressed_text(menu.x[c], menu.y[c], menu.name[c]);
                    break;

      case 0x4100 :  //F7
                    MSTEP2_STOP_ALL(CARD1);
                    break;
               //*******************************************************
      default:
                 MSTEP2_STOP_ALL(CARD1);
                 break;
      }
    if (c!=oldc)
    {
      unpressed_text(menu.x[oldc], menu.y[oldc], menu.name[oldc]);
      pressed_text(menu.x[c], menu.y[c], menu.name[c]);
      oldc=c;
    };
  } while (chkey!=0x011b); // ESC

 MSTEP2_RESET_SYSTEM(CARD1);
 textbackground(BLACK);
 clrscr();
 gotoxy(1,25);
}



